/* CCNET-RemotePipeline.kts */
/* Created by Enomoto Sanshiro on 1 December 2010. */


string host = "172.28.250.166";
int port = 2003;


datasource CCNET
{
    int adc_station = 3;

    NetworkModule ccnet("Toyo-CCNET-Remote");
    ccnet.connect(host, port);

    on run_begin {
	// initialize the command buffer //
	ccnet.initializeCommandBuffer();

	// construct command list //
	int n, f, a;
	ccnet.loadCamacCommand(n = adc_station, f = 0, a = 0); // READ
	ccnet.loadCamacCommand(n = adc_station, f = 0, a = 1);
	ccnet.loadCamacCommand(n = adc_station, f = 0, a = 2);
	ccnet.loadCamacCommand(n = adc_station, f = 0, a = 3);

	ccnet.loadCamacCommand(n = adc_station, f = 10, a = 0); // CLEAR LAM
	ccnet.loadCamacCommand(n = adc_station, f = 9, a = 0);  // CLEAR
    }

    on trigger(ccnet) {
	// CAMAC transaction //
        ccnet.execute();

	// read as block-type data //
        ccnet.blockRead();
    }
}
