/* mogura-scanner-test.cc */
/* Edited by Enomoto Sanshiro on 2 September 2010. */
/* Last updated by Enomoto Sanshiro on 2 September 2010. */


#include <iostream>
#include "MushArgumentList.hh"
#include "KinokoStandaloneComponent.hh"
#include "KinokoBuilderScannerTester.hh"
#include "MoguraEventPiece.hh"

using namespace std;


int main(int argc, char** argv)
{
    TMushArgumentList ArgumentList(argc, argv);
    string ConfigFileName = ArgumentList["--config"];
    string BuilderName = ArgumentList["--name"];
    if ((ArgumentList.NumberOfParameters() < 1) ||
	ConfigFileName.empty() || BuilderName.empty()
    ){
	cerr << "Usage: " << ArgumentList.ProgramName();
	cerr << " --config=CONFIG_FILE_NAME --name=BUILDER_NAME";
	cerr << " INPUT_FILE" << endl;
	return -1;
    }       
    
    TMoguraEventPieceScanner Scanner;

    TKinokoBuilderScannerDumper Dumper(cout);
    TKinokoBuilderScannerTester Tester(&Scanner, &Dumper);
    TKinokoStandaloneDataConsumer StandaloneConsumer(&Tester, "ScannerTester");

    try {
	Tester.Configure(ConfigFileName, BuilderName);
	StandaloneConsumer.Start(ArgumentList);
    }
    catch (TKinokoException &e) {
	cerr << "ERROR: " << argv[0] << ": " << e << endl;
    }
    
    return 0;
}
