/* KameJsonParser.hh */
/* Created by Enomoto Sanshiro on 4 April 2012. */
/* Last updated by Enomoto Sanshiro on 4 April 2012 */


#ifndef KameJsonParser_hh__
#define KameJsonParser_hh__

#include <iostream>
#include <string>
#include <deque>
#include "KameTree.hh"


namespace kame {


class TKameJsonTokenizer {
  public:
    TKameJsonTokenizer(std::istream& Input);
    virtual ~TKameJsonTokenizer();
    virtual bool GetNext(std::string& Token);
    virtual TKameJsonTokenizer& PushBack(const std::string& Token);
  protected:
    virtual bool Tokenize(std::string& Token);
    virtual char GetNextChar(void);
    virtual void PushBackChar(char Ch);
  protected:
    std::istream& _Input;
    std::deque<std::string> _TokenQueue;
    std::deque<char> _CharQueue;
};


class TKameJsonParser {
  public:
    TKameJsonParser(void);
    virtual ~TKameJsonParser();
    virtual void Parse(std::istream& Input, TKameTree& Tree);
  protected:
    virtual void ParseElement(TKameJsonTokenizer& Tokenizer, TKameTree& Tree);
    virtual void ParseIndexedArray(TKameJsonTokenizer& Tokenizer, TKameTree& Tree);
    virtual void ParseAssosiativeArray(TKameJsonTokenizer& Tokenizer, TKameTree& Tree);
};


}
#endif
