/* KameObject.hh */
/* Created by Enomoto Sanshiro on 8 July 2009. */
/* Last updated by Enomoto Sanshiro on 8 July 2009. */

#ifndef __KameObject_hh__
#define __KameObject_hh__


#include <string>
#include <vector>
#include <map>
#include "KameVariant.hh"
#include "KameTree.hh"


namespace kame {


class TKameObject {
  public:
    TKameObject(void) {}
    virtual ~TKameObject() {}
    virtual void SetTitle(const std::string& Title);
    virtual std::string Title(void) const;
    inline TKameTree& PropertyTree(void);
    inline const TKameTree& PropertyTree(void) const;
  private:
    mutable TKameTree _PropertyTree;
};


inline TKameTree& TKameObject::PropertyTree(void) 
{ 
    return _PropertyTree; 
}

inline const TKameTree& TKameObject::PropertyTree(void) const 
{ 
    return _PropertyTree; 
}


}
#endif
