/* KameTableFormat.hh */
/* Created by Enomoto Sanshiro on 1 July 2009. */
/* Last updated by Enomoto Sanshiro on 8 November 2011. */


#ifndef __KameTableFormat_hh__
#define __KameTableFormat_hh__


#include <string>
#include <map>
#include "KameTree.hh"
#include "KameNtuple.hh"
#include "KameTableFormatProcessor.hh"


namespace kame {


class TKameTableFormat {
  public:
    TKameTableFormat(void);
    virtual ~TKameTableFormat();
    virtual void EnableCsvHeader(void);
    virtual void SetDelimiter(char Delimiter);
    virtual void SetQuote(char Quote);
    virtual void SetLineTerminator(char LineTerminator);
    virtual void SetCommentHeader(char CommentHeader);
    virtual void SetTreeIndent(char TreeIndent);
    virtual void SetHeaderProcessor(TKameTableFormatHeaderProcessor* HeaderProcessor);
  public:
    virtual void Read(TKameNtuple& Ntuple, std::istream& Input);
    virtual void Write(const TKameNtuple& Ntuple, std::ostream& Output);
  protected:
    bool _IsCsvHeaderEnabled;
    char _DefaultDelimiter, _DefaultQuote, _LineTerminator;
    char _CommentHeader, _TreeIndent;
    TKameTableFormatHeaderProcessor* _HeaderProcessor;
  private:
    TKameTableFormatHeaderProcessor* _DefaultHeaderProcessor;
};


}
#endif
