/* KameTreeBuilder.hh */
/* Created by Enomoto Sanshiro on 8 November 2011. */
/* Last updated by Enomoto Sanshiro on 4 April 2012 */

#ifndef __KameTreeBuilder_hh__
#define __KameTreeBuilder_hh__


#include <iostream>
#include <string>
#include <deque>
#include "KameTree.hh"


namespace kame {


class TKameTreeBuilder {
  public:
    TKameTreeBuilder(TKameTree* Tree);
    virtual ~TKameTreeBuilder();
    virtual void DisableInlineJson(void);
    virtual void AddNode(int Depth, const std::string& Key, const std::string& Value);
    virtual void AppendLine(const std::string& Line);
  protected:
    bool _IsInlineJsonEnabled;
  private:
    int _CurrentDepth;
    TKameTree* _LastNode;
    std::deque<TKameTree*> _CurrentParentStack;
    std::deque<int> _DepthStepStack;
};


}
#endif
