/* KameTreeWalker.hh */
/* Created by Enomoto Sanshiro on 9 April 2012. */
/* Last updated by Enomoto Sanshiro on 9 April 2012. */

#ifndef __KameTreeWalker_hh__
#define __KameTreeWalker_hh__

#include <string>
#include "KameTree.hh"


namespace kame {

class TKameTreeHandler;


class TKameTreeWalker {
  public:
    TKameTreeWalker(TKameTreeHandler* Handler);
    virtual ~TKameTreeWalker();
    virtual void Process(TKameTree& Tree, std::string RootNodeName = "");
  protected:
    virtual void ProcessNode(const std::string& Name, TKameTree& Node);
  private:
    TKameTreeHandler* _Handler;
    TKameTree* _Tree;
};


class TKameTreeHandler {
  public:
    TKameTreeHandler(void) {}
    virtual ~TKameTreeHandler() {}
    virtual bool StartTree(TKameTree& Node) { return true; }
    virtual void EndTree(TKameTree& Node) {}
    virtual bool StartNode(const std::string& Name, TKameTree& Node, TKameTree& AttributeList) { return true; }
    virtual void EndNode(const std::string& Name, TKameTree& Node) {}
    virtual bool StartArray(const std::string& Name, TKameTree& Node) { return true; }
    virtual void EndArray(const std::string& Name, TKameTree& Node) {}
};


}
#endif
