// tree-test.cc //
/* Created by Enomoto Sanshiro on 4 November 2012. */

#include <string>
#include <iostream>
#include <time.h>
#include "KameTree.hh"

using namespace std;
using namespace kame;


int main(int argc, char** argv)
{
    TKameTree tree;

    // simple key-value pair
    tree["Title"] = "Test Tree";

    // more structured
    tree["MetaInformation/Creator"] = "tree-test.cxx";

    // multi-dimension array style, variant values
    tree["MetaInformation"]["Timestamp"] = (long) time(NULL);

    // sub-tree, XML-style attributes
    TKameTree& date = tree["MetaInformation/CreationDate"];
    date["Date"] = "04 Nov 2012 16:34:36";
    date["Date@TimeZone"] = "CET";

    // arrays
    TKameTree& fibonacci = tree["Fibonacci"];
    fibonacci[0] = 1;
    fibonacci[1] = 1;
    for (int i = 2; i < 8; i++) {
        fibonacci[i] = fibonacci[i-1].As<int>() + fibonacci[i-2].As<int>();
    }
        
    // writing in various formats
    TKameKtfTreeSerializer(cout).Serialize(tree);
    TKameXmlTreeSerializer(cout).Serialize(tree);
    TKameJsonTreeSerializer(cout).Serialize(tree);

    return 0;
}
