/* kame-variant-test */
/* Created by Enomoto Sanshiro on 22 July 2010. */
/* Last updated by Enomoto Sanshiro on 22 July 2010. */


#include <iostream>
#include <string>
#include "KameVariant.hh"

using namespace std;
using namespace kame;


namespace kame {
    class MyClass {
      public:
        string value;
    };

    template<> struct TKameVariantTraits<MyClass> {
        static MyClass As(const TKameVariant& Value) {
            MyClass c;
            c.value = "my value is: [" + Value.As<string>() + "]";
            return c;
        }
    };
}


int main(void)
{
    var a = 123;
    var b = "123";
    var c = "123";
    
    cout << "a: " << a << endl;
    cout << "b: " << b << endl;
    cout << "c: " << c << endl;
    cout << endl;

    a += 456;
    b += 456;
    c += 456;
    
    cout << "a: " << a << endl;
    cout << "b: " << b << endl;
    cout << "c: " << c << endl;
    cout << endl;

    a = (string) a + "789";
    b = b + 789;
    c = (int) c + 789;

    cout << "a: " << a << endl;
    cout << "b: " << b << endl;
    cout << "c: " << c << endl;
    cout << endl;

    // this can cause "ambiguous" error //
    enum { A };
    cout << (A + 1) << endl;

    var d = A;
    cout << d + 1 << endl;

    var xxx = 123;
    MyClass my = xxx.As<MyClass>();
    cout << my.value << endl;

    return 0;
}
