/* kntdump.cc */
/* Created by Enomoto Sanshiro on 1 July 2009. */
/* Last updated by Enomoto Sanshiro on 1 July 2009. */


#include <string>
#include <iostream>
#include <sstream>
#include "KameNtuple.hh"
#include "KamePlainTextRepository.hh"

using namespace std;
using namespace kame;


int main(int argc, char** argv)
{
    if (argc <= 1) {
	cerr << "USAGE: " << argv[0] << " FILENAME" << endl;
	return -1;
    }

    TKameNtuple Ntuple;
    try {
	TKamePlainTextRepository Repository;
	Repository.LoadNtuple(Ntuple, argv[1]);
    }
    catch (TKameException &e) {
	cerr << "ERROR: " << e << endl;
	return -1;
    }

    Ntuple.Dump(cout);

    return 0;
}
