/* knttree2xml.cc */
/* Created by Enomoto Sanshiro on 3 December 2011. */
/* Last updated by Enomoto Sanshiro on 3 December 2011. */


#include <string>
#include <iostream>
#include <sstream>
#include "KameTree.hh"
#include "KameTreeSerializer.hh"
#include "KameNtuple.hh"
#include "KamePlainTextRepository.hh"

using namespace std;
using namespace kame;


int main(int argc, char** argv)
{
    if (argc <= 1) {
	cerr << "USAGE: " << argv[0] << " FILENAME [ NODEPATH ]" << endl;
	return -1;
    }

    string RootNode = "";
    if (argc > 2) {
        RootNode = argv[2];
    }

    TKameNtuple Ntuple;
    try {
	TKamePlainTextRepository Repository;
	Repository.LoadNtuple(Ntuple, argv[1]);
    }
    catch (TKameException &e) {
	cerr << "ERROR: " << e << endl;
	return -1;
    }

    TKameXmlTreeSerializer(cout).Serialize(Ntuple[RootNode]);

    return 0;
}
