/* KaspXmlRepository.hh */
/* Created by Enomoto Sanshiro on 26 June 2002. */
/* Last updated by Enomoto Sanshiro on 26 June 2002. */


#ifndef __KaspXmlRepository_hh__
#define __KaspXmlRepository_hh__


#include <string>
#include <fstream>
#include "KaspConfig.hh"
#include "KaspRepository.hh"


class TKaspXmlRepository: public TKaspRepository {
  public:
    TKaspXmlRepository(const std::string& FileName);
    virtual ~TKaspXmlRepository();
    virtual void SaveNtuple(const std::string& Name, TKaspNtuple* Ntuple);
    virtual void SaveGraph(const std::string& Name, TKaspGraph* Graph);
    virtual void SaveHistogram(const std::string& Name, TKaspHistogram* Histogram);
    virtual void Save2dHistogram(const std::string& Name, TKasp2dHistogram* Histogram);
    virtual void SaveTrend(const std::string& Name, TKaspTrend* Trend);
    virtual void SaveHistory(const std::string& Name, TKaspHistory* History);
    virtual void SaveWave(const std::string& Name, TKaspWave* Wave);
    virtual void SaveMap(const std::string& Name, TKaspMap* Map);
    virtual void SaveTabular(const std::string& Name, TKaspTabular* Tabular);
    virtual TKaspNtuple* LoadNtuple(const std::string& Name, int Revision = -1);
    virtual TKaspGraph* LoadGraph(const std::string& Name, int Revision = -1);
    virtual TKaspHistogram* LoadHistogram(const std::string& Name, int Revision = -1);
    virtual TKasp2dHistogram* Load2dHistogram(const std::string& Name, int Revision = -1);
    virtual TKaspTrend* LoadTrend(const std::string& Name, int Revision = -1);
    virtual TKaspHistory* LoadHistory(const std::string& Name, int Revision = -1);
    virtual TKaspWave* LoadWave(const std::string& Name, int Revision = -1);
    virtual TKaspMap* LoadMap(const std::string& Name, int Revision = -1);
    virtual TKaspTabular* LoadTabular(const std::string& Name, int Revision = -1);
  protected:
    virtual void OpenToWrite(void);
    virtual void OpenToRead(void);
    virtual void Close(void);
  protected:
    std::ofstream* _OutputFile;
    std::ifstream* _InputFile;
    std::string _FileName;
};


#endif
