/* KdbcResult.hh */
/* Created by Enomoto Sanshiro on 3 November 2000. */
/* Last updated by Enomoto Sanshiro on 3 November 2000. */


#ifndef __KdbcResult_hh__
#define __KdbcResult_hh__

#include <iostream>
#include <string>
#include "KdbcDefs.hh"


class TKdbcResult {
  public:
    TKdbcResult(void);
    virtual ~TKdbcResult();
    virtual void Destroy(void) = 0;
    virtual bool IsQueryResult(void);
    virtual long NumberOfRows(void);
    virtual long NumberOfColumns(void);
    virtual long NumberOfAffectedRows(void);
    virtual std::string FieldNameOf(long Column) = 0;
    virtual std::string GetValueOf(long Row, long Column) = 0;
    virtual std::string GetValueOf(long Row, const std::string& FieldName) = 0;
  public:
    virtual bool Next(void);
    virtual std::string GetString(long Column);
    virtual std::string GetString(const std::string& FieldName);
    virtual long GetLong(long Column);
    virtual long GetLong(const std::string& FieldName);
    virtual double GetDouble(long Column);
    virtual double GetDouble(const std::string& FieldName);
    virtual void Dump(std::ostream& os);
  protected:
    bool _IsQueryResult;
    long _NumberOfRows, _NumberOfColumns, _NumberOfAffectedRows;
    long _CurrentRow;
};


#endif
