/* kernel/lib-common/mush/MushConfig.hh.  Generated from MushConfig.hh.in by configure.  */
/* MushConfig.hh.in */
/* Created by Enomoto Sanshiro on 21 January 1998. */
/* Last updated by Enomoto Sanshiro on 10 November 2000. */


#ifndef __MushConfig_hh__
#define __MushConfig_hh__


#define IS_SYSVFS_AVAILABLE 1
#define IS_BSDFS_AVAILABLE 1
#define SOCKLEN_IS_USED 1
#define ADDRLEN_IS_UNSIGNED 0
#define USE_ZLIB 1
#define USE_LIBXML 1
#define LIBXML_MAJOR_VERSION 2
#define USE_READLINE 1


#define SIZEOF_CHAR 1
#define SIZEOF_SHORT 2
#define SIZEOF_INT 4
#define SIZEOF_LONG 8
#define SIZEOF_LONG_LONG 8
#define SIZEOF_VOIDP 8
#define SIZEOF_SIZE_T 8
#define SIZEOF_OFF_T 8
#define SIZEOF_CADDR_T 8

#define FP_IS_IEEE754 1


namespace mush {

#if (SIZEOF_CHAR == 1)
typedef char Int8;
typedef unsigned char UInt8;
#else
#error Int8 is not set correctry
#endif

#if (SIZEOF_SHORT == 2)
typedef short Int16;
typedef unsigned short UInt16;
#else
#error Int16 is not set correctry
#endif

#if (SIZEOF_INT == 4)
typedef int Int32;
typedef unsigned int UInt32;
#else
#error Int32 is not set correctry
#endif

#if (SIZEOF_LONG == 8)
typedef long Int64;
typedef unsigned long UInt64;
#elif (SIZEOF_LONG_LONG == 8)
typedef long long Int64;
typedef unsigned long long UInt64;
#else
#error Int64 is not set correctry
#endif

};


inline float WordToFloat(mush::UInt32 x) 
{ 
#if FP_IS_IEEE754
    // type-punning (allowed by C99): avoid strict aliasing restriction //
    // SO/IEC 9899:1999 (C99) SC22/N2794 (WG14/N843), 6.5.16.1 (p81) //
    union {
	mush::UInt32 IntValue;
	float FloatValue;
    } Value;
    Value.IntValue = x;
    return Value.FloatValue;
#else
    throw TSystemCallExceptoin(
	"WordToFloat()", "unknown floating-point format"
    );
#endif
}

inline mush::UInt32 FloatToWord(float x) 
{
#if FP_IS_IEEE754
    // type-punning (allowed by C99): avoid strict aliasing restriction //
    // SO/IEC 9899:1999 (C99) SC22/N2794 (WG14/N843), 6.5.16.1 (p81) //
    union {
	mush::UInt32 IntValue;
	float FloatValue;
    } Value;
    Value.FloatValue = x;
    return Value.IntValue;
#else
    throw TSystemCallExceptoin(
	"FloatToWord()", "unknown floating-point format"
    );
#endif
}


#endif
