/* CanvasMessenger.hh */
/* Created by Enomoto Sanshiro on 19 October 2001. */
/* Last updated by Enomoto Sanshiro on 19 October 2001. */


#ifndef __CANVAS_MESSENGER_HH
#define __CANVAS_MESSENGER_HH


#include "Canvas.hh"
#include "ParaObject.hh"


class TCanvasMessenger: public TParaObjectPrototype {
  public:
    TCanvasMessenger(TCanvas* Canvas);
    virtual ~TCanvasMessenger();
    virtual TParaObjectPrototype* Clone(void);
    virtual void Construct(const std::string& ClassName, std::vector<TParaValue*>& ArgumentList);
    virtual void Destruct(void);
    virtual int InvokeMethodByName(const std::string& MethodName, std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
  protected:
    TParaValue DrawLine(std::vector<TParaValue*>& ArgumentList);
    TParaValue DrawRect(std::vector<TParaValue*>& ArgumentList);
    TParaValue DrawCircle(std::vector<TParaValue*>& ArgumentList);
    TParaValue DrawText(std::vector<TParaValue*>& ArgumentList);
  private:
    TCanvas* _Canvas;
};


class TCanvasFactory: public TParaObjectPrototype {
  public:
    TCanvasFactory(TCanvasMessenger* CanvasMessenger);
    virtual ~TCanvasFactory();
    virtual TParaObjectPrototype* Clone(void);
    virtual void Construct(const std::string& ClassName, std::vector<TParaValue*>& ArgumentList);
    virtual int InvokeMethodByName(const std::string& MethodName, std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
  protected:
    TParaValue GetCanvas(std::vector<TParaValue*>& ArgumentList);
  private:
    TCanvasMessenger* _CanvasMessenger;
    TParaValue* _CanvasPointer;
};


#endif
