/* RoomNetworkAccess.hh */
/* Created by Enomoto Sanshiro on 16 July 2009. */
/* Last updated by Enomoto Sanshiro on 16 July 2009. */


#ifndef __RoomNetworkAccess_hh__
#define __RoomNetworkAccess_hh__


#include <string>
#include "RoomModule.hh"


class TRoomNetworkConnection {
  public:
    TRoomNetworkConnection(bool IsTcp = true);
    virtual ~TRoomNetworkConnection();
    virtual int Connect(const std::string& RemoteHostName, int PortNumber);
    virtual bool ProbeNetwork(void);
    virtual int Send(const void* Data, size_t Size);
    virtual int Receive(void* Data, size_t MaxSize);
    virtual int SendBlock(const void* Data, size_t Size);
    virtual int ReceiveBlock(void* Data, size_t Size);
    virtual int ReceiveAvailable(void* Data, size_t MaxSize);
    virtual bool WaitArrival(int TimeOut_ms = 0);
  private:
    int _Socket;
    int _SocketType;
};


class TRoomNetworkModule: public TRoomModule, public TRoomNetworkConnection {
  public:
    TRoomNetworkModule(const std::string& ModuleType, const std::string& ModelName);
    virtual ~TRoomNetworkModule();
    virtual TRoomNetworkModule* Clone(void) = 0;
};


#endif
