/* controller-CAEN_VMELib.hh */
/* Created by Enomoto Sanshiro on 9 September 2014. */


#ifndef __controller_CAEN_VMELib_hh__
#define __controller_CAEN_VMELib_hh__


#include <sys/types.h>
#include "RoomVmeAccess.hh"


class TVmeController_CAEN_VMELib: public TRoomVmeController {
  public:
    enum TBoardType {
        btV1718,
        btV2718,
        _NumberOfBoardTypes
    };
  public:
    TVmeController_CAEN_VMELib(int BoardType);
    virtual ~TVmeController_CAEN_VMELib();
    virtual TRoomVmeController* CloneController(void);
  public:
    virtual TRoomVmeAccessProperty* Open(TRoomVmeTransferMode TransferMode);
    virtual void Close(TRoomVmeAccessProperty* Property);
    virtual long Read(TRoomVmeAccessProperty* Property, void* Buffer, int Size);
    virtual long Write(TRoomVmeAccessProperty* Property, const void* Buffer, int Size);
    virtual off_t Seek(TRoomVmeAccessProperty* Property, off_t OffsetAddress);
    virtual caddr_t Map(TRoomVmeAccessProperty* Property, off_t VmeAddress, size_t MapSize, off_t MapOffset);
    virtual void Unmap(TRoomVmeAccessProperty* Property);
    virtual void PutWord(TRoomVmeAccessProperty* Property, off_t OffsetAddress, Word Value);
    virtual Word GetWord(TRoomVmeAccessProperty* Property, off_t OffsetAddress);
    virtual void PutDoubleWord(TRoomVmeAccessProperty* Property, off_t OffsetAddress, DoubleWord Value);
    virtual DoubleWord GetDoubleWord(TRoomVmeAccessProperty* Property, off_t OffsetAddress);
    virtual long DmaRead(TRoomVmeAccessProperty* Property, void* Buffer, int Size);
    virtual long DmaWrite(TRoomVmeAccessProperty* Property, const void* Buffer, int Size);
    virtual off_t DmaSeek(TRoomVmeAccessProperty* Property, off_t OffsetAddress);
    virtual void RegisterInterruptNotification(TRoomVmeAccessProperty* Property, int SignalId = 0);
    virtual void UnregisterInterruptNotification(TRoomVmeAccessProperty* Property);
    virtual void EnableInterruptNotification(TRoomVmeAccessProperty* Property);
    virtual void DisableInterruptNotification(TRoomVmeAccessProperty* Property);
    virtual bool WaitForInterruptNotification(TRoomVmeAccessProperty* Property, unsigned TimeOut);
    virtual void SetInterruptNotificationAutodisable(TRoomVmeAccessProperty* Property);
    virtual bool IsSignalOnInterruptAvailable(void);
  public:
    int ReadInternalRegister(int Address);
    void WriteInternalRegister(int Address, int Data);
  protected:
    virtual const char* DeviceFileName(TRoomVmeTransferMode TransferMode);
    virtual const char* DmaDeviceFileName(TRoomVmeTransferMode TransferMode);
    virtual void DmaOpen(TRoomVmeAccessProperty* Property);
    virtual void DmaClose(TRoomVmeAccessProperty* Property);
  protected:
    bool _IsOpened;
    long _Handle;
    TBoardType _BoardType;
};


#endif
