/* controller-Kek_Camlib.hh */
/* Created by Enomoto Sanshiro on 23 October 1997. */
/* Updated by Enomoto Sanshiro on 8 July 2001. */
/* Last updated by Enomoto Sanshiro on 20 July 2009. */


#ifndef __controller_Kek_Camlib_hh__
#define __controller_Kek_Camlib_hh__


#include "RoomCamacAccess.hh" 


class TCamacController_Kek_Camlib: public TRoomCamacController {
  public:
    TCamacController_Kek_Camlib(void);
    virtual ~TCamacController_Kek_Camlib();
    virtual TRoomCamacController* CloneController(void);
    virtual void Open(void);
    virtual void Close(void);
  public:
    virtual int Transact(int StationNumber, int Function, int Address, int &Data, int &Q, int &X);
    virtual int Initialize(void);
    virtual int Clear(void);
    virtual int SetInhibit(void);
    virtual int ReleaseInhibit(void);
    virtual int EnableInterruptNotification(void);
    virtual int DisableInterruptNotification(void);
    virtual int ReadLam(int LamMask);
    virtual int WaitLam(int TimeLimit);
  private:
    bool _IsOpened;
    bool _IsInterruptNotificationEnabled;
};


#endif
