/* controller-UniverseII.hh */
/* Created by Enomoto Sanshiro on 21 April 2014. */


#ifndef __controller_UniverseII_hh__
#define __controller_UniverseII_hh__


#include <sys/types.h>
#include "RoomVmeAccess.hh"

class VMEBridge;


class TVmeController_UniverseII: public TRoomVmeController {
  public:
    TVmeController_UniverseII(void);
    virtual ~TVmeController_UniverseII();
    virtual TRoomVmeController* CloneController(void);
  public:
    virtual TRoomVmeAccessProperty* Open(TRoomVmeTransferMode TransferMode);
    virtual void Close(TRoomVmeAccessProperty* Property);
    virtual long Read(TRoomVmeAccessProperty* Property, void* Buffer, int Size);
    virtual long Write(TRoomVmeAccessProperty* Property, const void* Buffer, int Size);
    virtual off_t Seek(TRoomVmeAccessProperty* Property, off_t OffsetAddress);
    virtual caddr_t Map(TRoomVmeAccessProperty* Property, off_t VmeAddress, size_t MapSize, off_t MapOffset);
    virtual void Unmap(TRoomVmeAccessProperty* Property);
    virtual long DmaRead(TRoomVmeAccessProperty* Property, void* Buffer, int Size);
    virtual long DmaWrite(TRoomVmeAccessProperty* Property, const void* Buffer, int Size);
    virtual off_t DmaSeek(TRoomVmeAccessProperty* Property, off_t OffsetAddress);
    virtual void RegisterInterruptNotification(TRoomVmeAccessProperty* Property, int SignalId = 0);
    virtual void UnregisterInterruptNotification(TRoomVmeAccessProperty* Property);
    virtual void EnableInterruptNotification(TRoomVmeAccessProperty* Property);
    virtual void DisableInterruptNotification(TRoomVmeAccessProperty* Property);
    virtual bool WaitForInterruptNotification(TRoomVmeAccessProperty* Property, unsigned TimeOut);
    virtual void SetInterruptNotificationAutodisable(TRoomVmeAccessProperty* Property);
  public:
    virtual bool IsSignalOnInterruptAvailable(void);
  protected:
    virtual const char* DeviceFileName(TRoomVmeTransferMode TransferMode);
    virtual const char* DmaDeviceFileName(TRoomVmeTransferMode TransferMode);
    virtual void DmaOpen(TRoomVmeAccessProperty* Property);
    virtual void DmaClose(TRoomVmeAccessProperty* Property);
  protected:
    VMEBridge* _VmeBridge;
    int _OpenCount, _DmaOpenCount;
};


#endif
