/* module-CAEN_V260.cc */
/* Created by Enomoto Sanshiro on 12 September 2014. */


#include "RoomDeviceFactory.hh"
#include "RoomModule.hh"
#include "RoomVmeAccess.hh"
#include "module-CAEN_V260.hh"

using namespace std;


static TRoomVmeModuleCreator Creator3(
    "CAEN_V260", new TVmeScaler_CAEN_V260()
);


TVmeScaler_CAEN_V260::TVmeScaler_CAEN_V260(void)
: TRoomVmeModule("VmeScaler", "CAEN_V260", (TRoomVmeTransferMode) V260_TransferMode, (size_t) V260_MemorySize)
{
}

TVmeScaler_CAEN_V260::~TVmeScaler_CAEN_V260()
{
}

TRoomVmeModule* TVmeScaler_CAEN_V260::Clone(void)
{
    return new TVmeScaler_CAEN_V260();
}

int TVmeScaler_CAEN_V260::Initialize(int InitialState)
{
    Disable();
    Clear();

    return 0;
}

int TVmeScaler_CAEN_V260::Read(int Address, int &Data)
{
    if ((Address < 0) || (Address >= V260_NumberOfChannels)) {
	Data = 0;
	return 0;
    }

    Data = (
        ((GetWord(regChannelCounterBase + 4*Address + 0) & 0x00ff) << 16)
        |(GetWord(regChannelCounterBase + 4*Address + 2) & 0xffff)
    );

    return 1;
}

int TVmeScaler_CAEN_V260::Enable(int Address)
{
    PutWord(regReleaseInhibit, 0);

    return 0;
}

int TVmeScaler_CAEN_V260::Disable(int Address)
{
    PutWord(regSetInhibit, 0);
    
    return 0;
}

int TVmeScaler_CAEN_V260::Clear(int Address)
{
    PutWord(regClear, 0);
    
    return 0;
}

int TVmeScaler_CAEN_V260::NumberOfChannels(void)
{
    return V260_NumberOfChannels;
}
