/* module-CAEN_V260.hh */
/* Created by Enomoto Sanshiro on 12 September 2014. */


#ifndef __module_CAEN_V260_hh__
#define __module_CAEN_V260_hh__


#include "RoomModule.hh"
#include "RoomVmeAccess.hh"


/* VME 100MHz 16ch 24bit Scaler Model V260 (CAEN) */
class TVmeScaler_CAEN_V260: public TRoomVmeModule {
  public:
    TVmeScaler_CAEN_V260(void);
    virtual ~TVmeScaler_CAEN_V260();
    virtual TRoomVmeModule* Clone(void);
  public:
    virtual int Initialize(int InitialState = 0);
    virtual int Read(int Address, int& Data);
    virtual int Enable(int Address = -1);
    virtual int Disable(int Address = -1);
    virtual int Clear(int Address= -1);
    virtual int NumberOfChannels(void);
  private:
    enum TV260Parameters {
	V260_MemorySize = 0x1000,
	V260_TransferMode = VmeTransferMode_A24D16,
	V260_NumberOfChannels = 16,
	_NumberOfParameters
    };
    enum TV260Symbols {
	regChannelCounterBase = 0x000010,
	regClear = 0x000050,
	regSetInhibit = 0x000052,
	regReleaseInhibit = 0x000054,
	_NumberOfRegisters
    };
};


#endif
