/* module-SiTCP.hh */
/* Created by Enomoto Sanshiro on 27 July 1999. */
/* Last updated by Enomoto Sanshiro on 4 November 2001. */

#ifndef __module_SiTCP_hh__
#define __module_SiTCP_hh__

#include "RoomModule.hh"
#include "RoomNetworkAccess.hh"


class TNetworkMisc_SiTCP: public TRoomNetworkModule {
  public:    
    TNetworkMisc_SiTCP(void);
    virtual ~TNetworkMisc_SiTCP();
    virtual TRoomNetworkModule* Clone(void);
    virtual int Connect(const std::string& RemoteHostName, int PortNumber);
    virtual int ReadRegister(int Address, int& Data);
    virtual int WriteRegister(int Address, int Data);
    virtual int BlockRead(int Address, void *Data, int MaxSize);
    virtual int BlockWrite(int Address, const void *Data, int Size);
    virtual int NextDataBlockSize(int Address = -1);
  protected:
    virtual int Transact(int Command, int Address, int& Data);
  protected:
    TRoomNetworkConnection _RegisterFileConnection;
  private:
    int _TcpSocket, _UdpSocket;
    unsigned char _SequenceCount;
  private:
    int _DataBufferSize;
    unsigned char* _DataBuffer;
  protected:
    enum TCommand {
        Command_Read = 0xc0,
        Command_Write = 0x80,
        _NumberOfCommands
    };
};


#endif
