/* caen-vmelib-test.cc */
/* Created by Enomoto Sanshiro on 11 September 2014. */

#include <iostream>
#include <iomanip>
#include "RoomVmeAccess.hh"
#include "RoomDeviceFactory.hh"
#include "controller-CAEN_VMELib.hh"

using namespace std;

int main(void)
{
    TRoomDeviceFactory* DeviceFactory = TRoomDeviceFactory::GetInstance();

    TRoomVmeCrate* VmeCrate = DeviceFactory->CreateVmeCrate();
    TVmeController_CAEN_VMELib* VmeLib = (
        new TVmeController_CAEN_VMELib(TVmeController_CAEN_VMELib::btV2718)
    );

    VmeCrate->InstallController(VmeLib);

    try {
        //TRoomVmeAccessProperty* Property = VmeLib->Open(VmeTransferMode_A24D16);
        TRoomVmeAccessProperty* Property = VmeLib->Open(VmeTransferMode_A32D32);

	int FirmwareRevision = VmeLib->ReadInternalRegister(2);
	cout << "FirmwareRevision: " << (FirmwareRevision >> 8) << "." << (FirmwareRevision & 0x0f) << endl;
	
	VmeLib->PutDoubleWord(Property, 0x02000000, 0x1234abcd);
	cout << hex << VmeLib->GetDoubleWord(Property, 0x02000000) << endl;
	//cout << hex << VmeLib->GetWord(Property, 0x050000 + 0xfc) << endl;

	VmeLib->Close(Property);
    }
    catch (THardwareException &e) {
      cerr << "ERROR: " << e << endl;
    }

    delete VmeLib;
    delete VmeCrate;

    return 0;
}
