/* ccnet-remote-raw-test.cc */
/* Created by Enomoto Sanshiro on 13 January 2010. */
/* Last updated by Enomoto Sanshiro on 13 January 2010. */


#include <iostream>
#include <cstdlib>
#include "RoomNetworkAccess.hh"
#include "bridge-Toyo_CCNET.hh"

using namespace std;

static const string HostName = "172.28.119.110";
static const int PortNumber = 2003;
static const int AdcStation = 3;

int main(int argc, char** argv)
{
    TRoomNetworkConnection NetworkConnection;
    TMiscDevice_Toyo_CCNET CCNET;
    
    try {
	NetworkConnection.Connect(HostName, PortNumber);
	CCNET.CCNET_Open(&NetworkConnection);
	CCNET.CCNET_Reset();

	int N, A, F, Data, Q, X;
	CCNET.CCNET_ExecuteSingleCamac(N=25, A=0, F=17, Data, Q, X);  // Z
	CCNET.CCNET_ExecuteSingleCamac(N=25, A=0, F=16, Data, Q, X);  // C
	CCNET.CCNET_ExecuteSingleCamac(N=25, A=0, F=24, Data=0, Q, X); // RI

	CCNET.CCNET_EnableLam(0x00ffffff);

	// Enable //
	CCNET.CCNET_ExecuteSingleCamac(N=AdcStation, A=0, F=26, Data, Q, X);
	// Clear LAM //
	CCNET.CCNET_ExecuteSingleCamac(N=AdcStation, A=0, F=10, Data, Q, X);
	// Clear //
	CCNET.CCNET_ExecuteSingleCamac(N=AdcStation, A=0, F=9, Data, Q, X);

	int LamPattern = CCNET.CCNET_WaitLam(2000);
	if (LamPattern != 0) {
	    cout << "LAM Handled. Pattern: " << LamPattern << endl;
	    CCNET.CCNET_ExecuteSingleCamac(N=AdcStation, A=0, F=0, Data, Q, X);
	    cout << Data << " " << Q << " " << X << endl;
	}
	else {
	    cout << "LAM timed out" << endl;
	}

	CCNET.CCNET_DisableLam();
	CCNET.CCNET_Close();
    }
    catch (THardwareException &e) {
        cerr << "ERROR: " << e << endl;
	return -1;
    }

    return 0;
}
