
#include "RoomVmeAccess.hh"
#include "RoomDeviceFactory.hh"
#include "module-TrueTime_VMESG2.hh"

using namespace std;

static const unsigned BaseAddress = 0x4000;
static const int IRQ = 5;
static const unsigned Vector = 0xff31;
int main(void)
{
    try {
        TRoomDeviceFactory* DeviceFactory = TRoomDeviceFactory::GetInstance();
        
        TRoomVmeController* VmeController = DeviceFactory->CreateVmeController();
        TRoomVmeCrate* VmeCrate = DeviceFactory->CreateVmeCrate();
        TVmeTimingGenerator_TrueTime_VMESG2* Module = new TVmeTimingGenerator_TrueTime_VMESG2();
        
        VmeCrate->InstallController(VmeController);
        VmeCrate->Install(Module, BaseAddress, IRQ, Vector);
        
        Module->Initialize();
        
        cout << Module->ReadDays() << ",";
        cout << Module->ReadHours() << ":";
        cout << Module->ReadMinutes() << ":";
        cout << Module->ReadSeconds() << ":";
        cout << Module->ReadMilliSeconds() << ",";
        cout << endl;
        
        cout << Module->ReadExtEventDays() << ",";
        cout << Module->ReadExtEventHours() << ":";
        cout << Module->ReadExtEventMinutes() << ":";
        cout << Module->ReadExtEventSeconds() << ":";
        cout << Module->ReadExtEventMilliSeconds() << ",";
        cout << endl;
        
        Module->Finalize();
        
        delete Module;
        delete VmeCrate;
        delete VmeController;
    }
    catch (THardwareException &e) {
        cerr << "ERROR: " << e << endl;
    }
    
    return 0;
}
