/* KinokoHistogramWriter.hh */
/* Created by Enomoto Sanshiro on 29 October 1999. */
/* Last updated by Enomoto Sanshiro on 27 June 2002. */


#ifndef __KinokoHistogramWriter_hh__
#define __KinokoHistogramWriter_hh__


#include <string>
#include "KameHistogram.hh"
#include "KinokoSectionDataAnalyzer.hh"


class TKinokoHistogramWriter: public TKinokoSectionDataAnalyzer {
  public:
    TKinokoHistogramWriter(kame::TKameHistogram* Histogram, const std::string& SectionPath, const TKinokoDataElementSpecifier& ElementSpecifier, bool IsChannelHistogram);
    virtual ~TKinokoHistogramWriter();
    virtual void Destroy(void);
    virtual void Reset(void);
    virtual void SetTargetName(const std::string& Name);
    virtual void Dump(std::ostream& os, const std::string& Indent = "");
  protected:
    virtual int ProcessCommandPacket(void* Packet, TKinokoDataSource* DataSource);
    virtual int ProcessData(TKinokoSectionData* SectionData);
  protected:
    kame::TKameHistogram* _Histogram;
    std::string _SectionPath;
    TKinokoDataElementSpecifier _ElementSpecifier;
    bool _IsChannelHistogram;
    std::string _TargetName;
    long _StartTime;
    int _RunBeginCounts;
    int _AccumulationTimePropertyId;
};


#endif
