/* KinokoTabularWriter.hh */
/* Created by Enomoto Sanshiro on 25 January 2001. */
/* Updated by Enomoto Sanshiro on 27 June 2002. */
/* Last updated by Enomoto Sanshiro on 15 July 2009. */


#ifndef __KinokoTabularWriter_hh__
#define __KinokoTabularWriter_hh__


#include <string>
#include "KameTabular.hh"
#include "KinokoSectionDataAnalyzer.hh"


class TKinokoTabularWriter: public TKinokoSectionDataAnalyzer {
  public:
    TKinokoTabularWriter(kame::TKameTabular* Tabular, const std::string& SectionPath, const TKinokoDataElementSpecifier& ElementSpecifier);
    virtual ~TKinokoTabularWriter();
    virtual void Destroy(void);
    virtual void Reset(void);
    virtual void SetTargetName(const std::string& Name);
    virtual void Dump(std::ostream& os, const std::string& Indent = "");
  protected:
    virtual int ProcessData(TKinokoSectionData* SectionData);
  protected:
    kame::TKameTabular* _Tabular;
    std::string _SectionPath;
    TKinokoDataElementSpecifier _ElementSpecifier;
    std::string _TargetName;
};


#endif
