/* KinokoBuilderMonitor.hh */
/* Created by Enomoto Sanshiro on 1 September 2009. */
/* Last updated by Enomoto Sanshiro on 7 July 2010. */


#ifndef __KinokoBuilderMonitor_hh__
#define __KinokoBuilderMonitor_hh__

#include <string>
#include <iostream>
#include <vector>
#include "KinokoEventPiece.hh"
#include "KinokoEventSorter.hh"
#include "KinokoBuilderLogger.hh"


class TKinokoBuilderMonitor: protected TKinokoEventPieceDefs {
  public:
    TKinokoBuilderMonitor(void);
    virtual ~TKinokoBuilderMonitor(void);
    virtual void SetSorter(const TKinokoEventSorter* Sorter);
    virtual void Report(void) {}
    virtual void ReportSummary(void) {}
    virtual void Dump(std::ostream& Output);
  protected:
    const TKinokoEventSorter* _Sorter;
};


class TKinokoBuilderCompositeMonitor: public TKinokoBuilderMonitor {
  public:
    TKinokoBuilderCompositeMonitor(void);
    virtual ~TKinokoBuilderCompositeMonitor(void);
    virtual void AddMonitor(TKinokoBuilderMonitor* Monitor);
    virtual void SetSorter(const TKinokoEventSorter* Sorter);
    virtual void Report(void);
    virtual void ReportSummary(void);
  protected:
    std::vector<TKinokoBuilderMonitor*> _MonitorList;
};


class TKinokoBuilderLoggingMonitor: public TKinokoBuilderMonitor {
  public:
    TKinokoBuilderLoggingMonitor(TKinokoBuilderLogger* Logger);
    virtual ~TKinokoBuilderLoggingMonitor();
    virtual void Report(void);
    virtual void ReportSummary(void);
  protected:
    TKinokoBuilderLogger* _Logger;
};


class TKinokoBuilderSummaryReport: public TKinokoBuilderMonitor {
  public:
    TKinokoBuilderSummaryReport(std::ostream& os);
    virtual ~TKinokoBuilderSummaryReport(void);
    virtual void ReportSummary(void);
  protected:
    std::ostream& _Output;
};


#endif
