/* KinokoBuilderScannerTest.hh */
/* Edited by Enomoto Sanshiro on 2 September 2010. */
/* Last updated by Enomoto Sanshiro on 2 September 2010. */


#ifndef __KinokoBuilderScannerTester_hh__
#define __KinokoBuilderScannerTester_hh__


#include <iostream>
#include "MushArgumentList.hh"
#include "KinokoHorizontalBuilder.hh"
#include "KinokoBuilderInlet.hh"
#include "KinokoEventChopper.hh"
#include "KinokoDataProcessor.hh"


class TKinokoBuilderScannerDumper: protected TKinokoEventPieceDefs {
  public:
    TKinokoBuilderScannerDumper(std::ostream& Output);
    virtual ~TKinokoBuilderScannerDumper();
    virtual void DumpInputRunBegin(void);
    virtual void DumpInputRunEnd(void);
    virtual void DumpInputPacket(int SectionId, void* Data, int Size);
    virtual void DumpOutputPiece(const TKinokoEventPiece& EventPiece);
  protected:
    std::ostream& _Output;
};


class TKinokoBuilderScannerTester: public TKinokoDataConsumer, public TKinokoBuilderDataSectionInlet {
  public:
    TKinokoBuilderScannerTester(TKinokoEventPieceScanner* Scanner, TKinokoBuilderScannerDumper* Dumper);
    virtual ~TKinokoBuilderScannerTester();
    virtual void Configure(const std::string& ConfigFileName, const std::string& BuilderName);
  public:
    // DataProcessor Interface //
    virtual void OnConstruct(void);
    virtual void OnRunBegin(void);
    virtual void OnRunEnd(void);
    virtual void OnReceivePacket(void* Packet, long PacketSize);
  protected:
    TKinokoEventPieceScanner* _Scanner;
    TKinokoBuilderScannerDumper* _Dumper;
    TKinokoBuilderInlet* _BuilderInlet;
    TKinokoEventChopper* _Chopper;
    TKinokoEventPieceProcessor* _OutputProcessor;
};


#endif
