/* KinokoEventProcessor.hh */
/* Created by Enomoto Sanshiro on 4 September 2009. */
/* Last updated by Enomoto Sanshiro on 4 September 2009. */


#ifndef __KinokoEventProcessor_hh__
#define __KinokoEventProcessor_hh__


#include <string>
#include <iostream>
#include "KinokoDataProcessor.hh"
#include "KinokoEventEnvelope.hh"


class TKinokoEventProcessor: public TKinokoDataProcessor {
  public:
    TKinokoEventProcessor(const std::string& InputDataSourceName, TKinokoEventSegmentProcessor* SegmentProcessor);
    virtual ~TKinokoEventProcessor();
    virtual void SetLogger(TKinokoBuilderLogger* Logger);
    virtual void BuildDataSource(TKinokoDataSource* DataSource) = 0;
  protected:
    virtual void OnReceivePacket(void* Packet, long PacketSize);
  protected:
    TKinokoEventEnvelopeReader* _EnvelopeReader;
    TKinokoEventSegmentProcessor* _SegmentProcessor;
};


class TKinokoEventConsumer: public TKinokoDataConsumer {
  public:
    TKinokoEventConsumer(const std::string& InputDataSourceName, TKinokoEventSegmentProcessor* SegmentProcessor);
    virtual ~TKinokoEventConsumer();
    virtual void SetLogger(TKinokoBuilderLogger* Logger);
  protected:
    virtual void OnReceivePacket(void* Packet, long PacketSize);
  protected:
    TKinokoEventEnvelopeReader* _EnvelopeReader;
    TKinokoEventSegmentProcessor* _SegmentProcessor;
};


#endif
