/* KinokoHorizontalBuilder.hh */
/* Created by Enomoto Sanshiro on 25 August 2009. */
/* Last updated by Enomoto Sanshiro on 8 May 2010. */


#ifndef __KinokoHorizontalBuilder_hh__
#define __KinokoHorizontalBuilder_hh__


#include <string>
#include <iostream>
#include <vector>
#include "KinokoBuilderInlet.hh"
#include "KinokoEventChopper.hh"
#include "KinokoEventSorter.hh"
#include "KinokoSorterProcessor.hh"
#include "KinokoBuilder.hh"


class TKinokoBuilderDataSectionInlet {
  public:
    TKinokoBuilderDataSectionInlet(void);
    virtual ~TKinokoBuilderDataSectionInlet();
    virtual void SetTargetDataSource(const std::string& DataSourceName);
    virtual void AddTargetDataSection(const std::string& DataSectionName, TKinokoEventPieceDefs::TStreamKey StreamKey = -1);
  protected:
    std::string _InputDataSourceName;
    std::vector<std::pair<std::string, TKinokoEventPieceDefs::TStreamKey> > _InputDataSectionNameList;
};


class TKinokoHorizontalBuilder: public TKinokoBuilder, public TKinokoBuilderDataSectionInlet {
  public:
    TKinokoHorizontalBuilder(void);
    virtual ~TKinokoHorizontalBuilder();
    virtual void SetPieceScanner(TKinokoEventPieceScanner* Scanner);
  protected:
    virtual TKinokoEventSorter& BuilderConstruct(void);
    virtual void BuilderBegin(void);
    virtual void BuilderEnd(void);
    virtual int BuilderProcess(void* Packet, long PacketSize);
  protected:
    TKinokoEventPieceScanner* _PieceScanner;
    TKinokoEventChopper* _Chopper;
    TKinokoEventPieceSorter* _Sorter;
    TKinokoBuilderInlet* _BuilderInlet;
};


#endif
