/* KinokoMemoryPool.hh */
/* Created by Enomoto Sanshiro on 26 November 2010. */
/* Updated by Enomoto Sanshiro on 26 November 2010. */


#ifndef __KinokoMemoryPool_hh__
#define __KinokoMemoryPool_hh__

#include <iostream>
#include <map>


class TKinokoMemoryPool {
  public:
    TKinokoMemoryPool(size_t Capacity = 0);
    virtual ~TKinokoMemoryPool();
    virtual void Initialize(void);
    virtual void Finalize(void);
    virtual void* Allocate(size_t Size);
    virtual void Release(const void* Address);
  public:
    virtual size_t Capacity(void) const;
    virtual size_t AvailableSize(void) const;
    virtual int NumberOfEntries(void) const;
    virtual size_t UsedSize(void) const;
    virtual size_t MaximumUsage(void) const;
  private:
    size_t _Capacity, _UsedSize;
    int _NumberOfEntries;
    std::map<const void*, size_t> _EntryTable;
    size_t _MaximumUsage;
  private:
    typedef long long Word;
};


#endif
