/* KinokoVerticalBuilder.hh */
/* Created by Enomoto Sanshiro on 28 August 2009. */
/* Last updated by Enomoto Sanshiro on 8 May 2010. */


#ifndef __KinokoVerticalBuilder_hh__
#define __KinokoVerticalBuilder_hh__


#include <string>
#include <iostream>
#include <vector>
#include "KinokoEventSorter.hh"
#include "KinokoSorterProcessor.hh"
#include "KinokoBuilder.hh"


class TKinokoBuilderDataSourceInlet {
  public:
    TKinokoBuilderDataSourceInlet(void);
    virtual ~TKinokoBuilderDataSourceInlet();
    virtual void AddTargetDataSource(const std::string& DataSourceName, TKinokoEventPieceDefs::TStreamKey StreamKey = -1);
  protected:
    std::vector<std::pair<std::string, TKinokoEventPieceDefs::TStreamKey> > _InputDataSourceNameList;
};


class TKinokoVerticalBuilder: public TKinokoBuilder, public TKinokoBuilderDataSourceInlet {
  public:
    TKinokoVerticalBuilder(void);
    virtual ~TKinokoVerticalBuilder();
  protected:
    // Builder Interface //
    virtual TKinokoEventSorter& BuilderConstruct(void);
    virtual void BuilderBegin(void);
    virtual void BuilderEnd(void);
    virtual int BuilderProcess(void* Packet, long PacketSize);
  protected:
    TKinokoEventSegmentSorter* _Sorter;
    TKinokoEventEnvelopeReader* _EnvelopeReader;
};


#endif
