/* KinokoConsoleCom.hh */
/* Created by Enomoto Sanshiro on 22 August 2002. */
/* Last updated by Enomoto Sanshiro on 22 August 2002. */


#ifndef __KinokoConsoleCom_hh__
#define __KinokoConsoleCom_hh__


#include <string>
#include <vector>
#include "KinokoComponentPlatform.hh"
#include "KinokoSystemComponent.hh"
#include "KinokoConsole.hh"


class TKinokoConsoleCom: public TKinokoSystemComponent {
  public:
    TKinokoConsoleCom(void);
    virtual ~TKinokoConsoleCom();
    virtual void BuildDescriptor(TKcomComponentDescriptor& Descriptor);
    virtual void Initialize(void);
    virtual void Finalize(void);
    virtual int ProcessEvent(int EventId, TKcomEvent& Event, TKcomEventResponse& EventResponse);
    virtual int DoTransaction(void);
  protected:
    virtual int ProcessPrintEvent(TKcomEvent& Event);
    virtual int ProcessExecuteEvent(TKcomEvent& Event, TKcomEventResponse& Response);
    virtual void OnQuit(void);
  protected:
    enum TEventId {
	EventId_Print = TKinokoSystemComponent::_NumberOfEvents,
	EventId_Execute,
	_NumberOfEvent
    };
  protected:
    TKinokoEventEmitter* _EventEmitter;
    TKinokoRegistry* _Registry;
    TKinokoTerminal* _Terminal;
    TKinokoConsole* _Console;
};


#endif
