/* KinokoSocketStream.hh */
/* Created by Enomoto Sanshiro on 23 February 1998. */
/* Last updated by Enomoto Sanshiro on 17 April 2001. */


#ifndef __KinokoSocketStream_hh__
#define __KinokoSocketStream_hh__


#include "MushDecoratedSocket.hh"
#include "MushSocketSelector.hh"
#include "KinokoStream.hh"


class TKinokoInputSocketStream: public TKinokoInputStream {
  public:
    TKinokoInputSocketStream(TMushFramedSocket *Socket, int LocalBufferSize = 1024*1024, int LocalBufferEntryTableSize = 4096);
    virtual ~TKinokoInputSocketStream();
    virtual void Destroy(void);
    virtual bool HasData(void);
    virtual size_t NextDataSize(void);
    virtual int Read(void *Address, size_t MaxSize);
    virtual int NextEntry(void *&Address);
    virtual void Flush(void* Address);
    virtual int GetEntry(void *&Address);
    virtual void ReleaseEntry(void* Address);
  protected:
    TMushSocketSelector* _SocketSelector;
    TMushFramedSocket *_Socket;
};


class TKinokoOutputSocketStream: public TKinokoOutputStream {
  public:
    TKinokoOutputSocketStream(TMushFramedSocket *Socket, int LocalBufferSize = 1024*1024, int LocalBufferEntryTableSize = 4096);
    virtual ~TKinokoOutputSocketStream();
    virtual void Destroy(void);
    virtual int Write(void *Address, size_t Size);
    virtual int NextEntry(void *&Address, size_t MaxSize);
    virtual int Flush(void* Address, size_t Size);
    virtual int GetEntry(void *&Address, size_t MaxSize);
    virtual int ReleaseEntry(void* Address, size_t Size);
  protected:
    TMushFramedSocket *_Socket;
};


#endif
