/* KinokoControlViewletMessenger.hh */
/* Created by Enomoto Sanshiro on 12 August 2007. */
/* Last updated by Enomoto Sanshiro on 12 August 2007. */


#ifndef __KinokoControlViewletMessenger_hh__
#define __KinokoControlViewletMessenger_hh__


#include <string>
#include <vector>
#include "KiscScript.hh"
#include "KinokoControl.hh"
#include "KinokoControlScript.hh"


class TKinokoControlCanvasViewletMessenger: public TKinokoControlWidgetMessenger {
  public:
    TKinokoControlCanvasViewletMessenger(TKinokoControlCanvasViewlet* CanvasViewlet);
    virtual ~TKinokoControlCanvasViewletMessenger();
    virtual int MethodIdOf(const std::string& MethodName);
    virtual int InvokeMethod(int MethodId, std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
  protected:
    int Clear(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int DrawLine(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int DrawCircle(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int DrawText(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
  protected:
    enum {
	MethodId_Clear = TKinokoControlWidgetMessenger::_NumberOfMethods,
	MethodId_DrawLine,
	MethodId_DrawCircle,
	MethodId_DrawText,
	_NumberOfMethods
    };
  protected:
    TKinokoControlCanvasViewlet* _CanvasViewlet;
};


class TKinokoControlPlotViewletMessenger: public TKinokoControlWidgetMessenger {
  public:
    TKinokoControlPlotViewletMessenger(TKinokoControlPlotViewlet* PlotViewlet);
    virtual ~TKinokoControlPlotViewletMessenger();
    virtual int MethodIdOf(const std::string& MethodName);
    virtual int InvokeMethod(int MethodId, std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
  protected:
    int Clear(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int SetRange(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int ResetRange(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int GuessRange(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int SetColor(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int SetLineWidth(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int SetMarker(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int SetYScaleLog(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int SetTimeTick(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
    int Draw(std::vector<TParaValue*>& ArgumentList, TParaValue& ReturnValue);
  protected:
    enum {
	MethodId_Clear = TKinokoControlWidgetMessenger::_NumberOfMethods,
	MethodId_SetRange,
	MethodId_ResetRange,
	MethodId_GuessRange,
	MethodId_SetColor,
	MethodId_SetLineWidth,
	MethodId_SetMarker,
	MethodId_SetYScaleLog,
	MethodId_SetTimeTick,
	MethodId_Draw,
	_NumberOfMethods
    };
  protected:
    TKinokoControlPlotViewlet* _PlotViewlet;
};


#endif
